<?php
  //============================================================================
  // DirCaster 0.7b, released 01/03/2007. http://www.DirCaster.org
  //============================================================================
  // Open Source code but please leave all references to prior work intact 
  // when making changes.
  //
  // Current maintainer: Dr. Bill Bailey - DrBill@DirCaster.org
  //
  // Based on the original DirCaster by Ryan King (http://www.shadydentist.com)
  // ID3v2.x tag support added by Warren Stone <fasttr@gmail.com> and
  // utilizing getid3 library by James Heinrich <info@getid3.org>,
  // http://www.getid3.org. iTunes specific tag support by Warren Stone
  // need to include the code to read id3 tags
  // also reads lots of different formats
  // we'll implement mp3, mpa (quicktime), asf (wma) and riff (wav/avi)
  // alter the path to your getid3 directory location
  //============================================================================
  // ChangeLog for DirCaster Version 0.7b
  //============================================================================
  // Fixed the same problem as "pubDate" for "LastBuildDate" in iTunes Feed
  // 2007-01-03 Dr. Bill Bailey
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.7a
  //============================================================================
  // 2006-12-25 H. L. Ratliff
  //  . Fixed several PHP Notice errors issued when error level set to ALL
  //  . Patched occasion where single digit day in pubdate sometimes
  //    displayed for example '  1' instead of ' 01'. new function fixDat()
  //  . Substituted RSS title tag value with file name when id3 title value
  //    is empty. stripType() drops the file extension
  //  . Corrected raw '&' in RSS title tag (use '&amp;' instead)
  //  . Fixed variable name error which caused, the logic to produce only
  //    a set number of feeds, not to work.  Controlled by $maxFeeds.
  //
  // Many, many thanks to Henry from the DirCaster Maintainer!
  //============================================================================
  // DirCaster specific variables (Change the items below to match YOUR feed)
  //============================================================================
  // Podcast Title Variable
  $titleTAG       = "Dr. Bill: The Computer Curmudgeon";
  // Podcast Discription
  $descriptionTAG = "Tech Tips, Tech News, the Web and other various musings from Dr. Bill Bailey at Dr. Bill Bailey.NET.  Join Dr. Bill as he makes pointed, funny, and sometimes, controversial observations on Tech Life.";
  // Your Website URL
  $linkTAG        = "http://www.TheComputerCurmudgeon.com";
  // For iTunes "New Feed" feature - to change your URL for the feed - should it
  // ever be necessary - also set the "$NEWfeedURL_ON" value to "yes" to
  // activate it.
  $NEWfeedURL     = "http://podcast.TheComputerCurmudgeon.com/dircaster.php";
  $NEWfeedURL_ON  = "no";
  // Your Copyright String
  $copyrightTAG   = "Dr. Bill Bailey";
  // Podcast Language Tag
  $languageTAG    = "en-us";
  // Site Webmaster E-mail Address
  $webMasterTAG   = "DrBill@TheComputerCurmudgeon.com";
  // Give The DirCaster Project some "props!"
  $generatorTAG   = "DirCaster V0.7b - www.DirCaster.org";
  // "Time to Live"
  $ttlTAG         = "60";
  // Your image should be 144 by 144 pixels - (gif, jpg, or png)
  $rssImageUrlTAG   = "http://www.TheComputerCurmudgeon.com/images/DrBillImage144.gif";
  // Image Tag
  $rssImageTitleTAG = "DrBill Logo";
  // Image Link
  $rssImageLinkTAG  = "http://www.TheComputerCurmudgeon.com";
  // Set the "maxFeeds" variable to the number of podcasts you want displayed
  // in the feed when it is accessed... in this way, you can limit the number
  // shown, speeding up execution.
  $maxFeeds         = "25";
  // Allowed File Types in Feed
  $sftypes          = "(.mp3 .m4a .m4b .asf .wma .avi .mov)";
  // location of the "getid3" library - should be the default unless you changed
  // it in your directory structure.
  $id3LibPath       = "./lib_getid3/getid3/getid3.php";
  // Delimiter
  $delim1 = ' ';
  //---------------------------------------------------------------------------
  // iTunes specific tags below - See iTunes RSS feed tech info for details at:
  // http://www.apple.com/itunes/store/podcaststechspecs.html#_Toc526931674
  // iTunes specific tags
  //---------------------------------------------------------------------------
  $nameSpaceTAG   = "http://www.itunes.com/dtds/podcast-1.0.dtd";
  $explicitTAG    = "no";
  $summaryTAG     = "Tech Tips, Tech News, the Web and other various musings from Dr. Bill Bailey at Dr. Bill Bailey.NET.  Join Dr. Bill as he makes pointed, funny, and sometimes, controversial observations on Tech Life.";
  $authorTAG      = "Dr. Bill Bailey";
  $ownerNameTAG   = "Dr. Bill Bailey";
  $ownerEmailTAG  = "DrBill@TheComputerCurmudgeon.com";
  $topCategoryTAG = "Technology";
  $subCategoryTAG = "Tech News";
  $keywordTAG     = "bill bailey,dr. bill bailey,computers, systems, open source, linux, windows, web, internet, tech, technology, tech news, computer, curmudgeon";
  $imageUrlTAG    = "http://www.TheComputerCurmudgeon.com/images/DrBillImage144.gif";
  $imageTitleTAG  = "DrBill Logo";
  $imageLinkTAG   = "http://www.TheComputerCurmudgeon.com";
  $imageItemTAG   = "no";
  //============================================================================
  //
  // end of DirCaster Variables.
  //
  //============================================================================
  //
  // Do not edit anything below this line un less you know what you are doing!
  //
  /* Main Code ****************************************************************/

  require_once($id3LibPath);

  // lets make all of the user set variables xml compliant just in case
  $titleTAG         = escChars ($titleTAG);
  $descriptionTAG   = escChars ($descriptionTAG);
  $copyrightTAG     = escChars ($copyrightTAG);
  $languageTAG      = escChars ($languageTAG);
  $webMasterTAG     = escChars ($webMasterTAG);
  $generatorTAG     = escChars ($generatorTAG);;
  $rssImageTitleTAG = escChars ($rssImageTitleTAG);
  $summaryTAG       = escChars ($summaryTAG);
  $authorTAG        = escChars ($authorTAG);
  $ownerNameTAG     = escChars ($ownerNameTAG);
  $ownerEmailTAG    = escChars ($ownerEmailTAG);
  $topCategoryTAG   = escChars ($topCategoryTAG);
  $subCategoryTAG   = escChars ($subCategoryTAG);
  $keywordTAG       = escChars ($keywordTAG);
  $imageTitleTAG    = escChars ($imageTitleTAG);

  header('Content-type: text/xml', true);
  $rootMP3URL = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
  $rootMP3URL =  substr($rootMP3URL, 0, strrpos ($rootMP3URL, "/")); // Trim off script name itself

  print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  print "<rss xmlns:itunes=\"$nameSpaceTAG\" version=\"2.0\">\n";

  print" <channel>\n";
  // original dircaster channel info
  if ($NEWfeedURL_ON == "yes") {
    print"     <itunes:new-feed-url>$NEWfeedURL</itunes:new-feed-url>\n";
  }
  print"  <title>$titleTAG</title>\n";
  print"  <link>$linkTAG</link>\n";
  print"  <description>$descriptionTAG</description>\n";
  print"  <category>$topCategoryTAG</category>\n";
  print"  <pubDate>" . fixDate( date("r") ) ."</pubDate>\n";
  print"  <lastBuildDate>" . fixDate( date("r") ) ."</lastBuildDate>\n";
  print"  <language>$languageTAG</language>\n";
  print"  <copyright>$copyrightTAG</copyright>\n";
  print"  <generator>$generatorTAG</generator>\n";
  print"  <managingEditor>$ownerEmailTAG ($ownerNameTAG)</managingEditor>\n";
  print"  <webMaster>$webMasterTAG</webMaster>\n";
  print"  <ttl>$ttlTAG</ttl>\n\n";

  // new itunes channel stuff
  // itunes author tag
  print"      <itunes:author>$authorTAG</itunes:author>\n";
  // itune subtitle tag
  print"      <itunes:subtitle>$descriptionTAG</itunes:subtitle>\n";
  // itunes category tags
  print"      <itunes:category text=\"".$topCategoryTAG."\">\n";
  print"   <itunes:category text=\"".$subCategoryTAG."\"/>\n";
  print"  </itunes:category>\n";
  // itunes summary tag
  print"      <itunes:summary>$summaryTAG</itunes:summary>\n";
  // itunes owner tags
  print"      <itunes:owner>\n";
  print"      <itunes:name>$ownerNameTAG</itunes:name>\n";
  print"      <itunes:email>$ownerEmailTAG</itunes:email>\n";
  print"      </itunes:owner>\n";
  // itunes explicit tag
  print"      <itunes:explicit>$explicitTAG</itunes:explicit>\n";
  // image tags
  print"      <itunes:image href=\"$rssImageUrlTAG\" />\n";
  print"  <image>\n";
  print"   <url>".$rssImageUrlTAG."</url>\n";
  print"   <title>".$rssImageTitleTAG."</title>\n";
  print"   <link>".$rssImageLinkTAG."</link>\n";
  print"  </image>\n";
  // item listing
  $dirArray = getDir(".", $sftypes); // Get a list of the current directory
  while ( list($filename, $filedate ) = each($dirArray) AND $maxFeeds > 0) {
    $mp3file = new CMP3File;
    $mp3file->getid3 ($filename);
    echo "<item>\n";

    // title tag
    $title = str_replace("_", " ", $mp3file->title);
    //handle empty title in id3 tag
    if ( empty( $title ) ){
      //use file name, drop file extension
      $title = stripType( $delim1, $sftypes, $filename );
    }
    //handle '&' in names
    $title = htmlentities( $title );

    echo ("<title>".$title."</title>\n"); // title string
    $url = $rootMP3URL."/". htmlentities(str_replace(" ", "%20", $filename));
    echo ("<link>".$url."</link>\n"); //link string

    // artist
    $artist = $mp3file->artist;
    echo ("<author>$ownerEmailTAG</author>\n");
    echo ("<description>$title - $mp3file->album - ".$artist."</description>\n");
    echo ("<pubDate>". fixDate( date("r", $filedate) ) ."</pubDate>\n");
    echo ("<enclosure url=\"".$url."\" length=\"".filesize($filename)."\" type=\"$mp3file->mime_type\"/>\n");
    echo ("<itunes:author>$artist</itunes:author>\n");
    echo ("<itunes:subtitle>$mp3file->comment</itunes:subtitle>\n");
    echo ("<itunes:keywords>$keywordTAG</itunes:keywords>\n");
    // check to see if we want image info for each item
    if ($imageItemTAG == "yes") {
      echo ("<itunes:link rel=\"image\" type=\"video/jpeg\" href=\"$imageUrlTAG\">$imageTitleTAG</itunes:link>\n");
    }
    $fix_duration = $mp3file->duration;
    if (strlen($fix_duration) < 3) {
      $fix_duration = "00:00:".$fix_duration;
    }
    if (strlen($fix_duration) < 6) {
      $fix_duration = "00:".$fix_duration;
    }
    echo ("<itunes:duration>$fix_duration</itunes:duration>\n");
    echo ("<guid>".$url."</guid>\n");
    print "</item>\n\n";
    $maxFeeds--;
  }// end while

  print "</channel>\n</rss>\n";

  //---------------------------------------------------
  // Functions and Classes
  //---------------------------------------------------
  function fixDate( $filedate ){
    // patch for dates reurned with 1 digit day of month with leading space
    if ( strPos( $filedate, '  ' ) !== FALSE ){
      // version 1 - this dros one space ('  4' = ' 4') and works in the validator
      //$filedate = str_replace( '  ', ' ', $filedate );
      // version 2 replaces the space with a 0 ( '  4' = ' 04')
      $filedate = str_replace( 'Sun,  ', 'Sun, 0', $filedate );
      $filedate = str_replace( 'Mon,  ', 'Mon, 0', $filedate );
      $filedate = str_replace( 'Tue,  ', 'Tue, 0', $filedate );
      $filedate = str_replace( 'Wed,  ', 'Wed, 0', $filedate );
      $filedate = str_replace( 'Thu,  ', 'Thu, 0', $filedate );
      $filedate = str_replace( 'Fri,  ', 'Fri, 0', $filedate );
      $filedate = str_replace( 'Sat,  ', 'Sat, 0', $filedate );
    }
    return $filedate;
  }//end function

  function stripType( $delim, $types, $str ){
    // strip file extensions form file name per $sfTypes string
    $types = str_replace( '(', '', $types );
    $types = str_replace( ')', '', $types );
    $aTypes = explode( $delim, $types );

    $cnt = count( $aTypes );
    for ( $i = 0; $i < $cnt; $i++ ){
      $str = str_replace( $aTypes[ $i ], '', $str );
    }

    return $str;
  }// end function

  function stripJunk ($text) {
    // Strip non-text characters
    $outText = '';
    for ($c=0; $c<strlen($text); $c++) {
      if ( ord($text[$c] ) >= 32 AND ord( $text[$c] ) <= 122 )
        $outText.=$text[$c];
    }// end for
    return $outText;
  }// end function

  function escChars ($text) {
    // Strip non-text characters
    $fixed = str_replace("&","&#38;", $text);
    $fixed = str_replace("<","&#60;",$fixed);
    $fixed = str_replace("","&#169;",$fixed);
    $outText = str_replace(">","&#62;",$fixed);
    return $outText;
  }

  class CMP3File {
    //properties
    var $title;
    var $artist;
    var $album;
    var $year;
    var $comment;
    var $genre;
    var $composer;
    var $copyright;
    var $mime_type;
    var $duration;

    function getid3 ($file) {
      // Initialize getID3 engine
      if ( file_exists($file) ) {
        //after verifying the file exists,
        $getID3 = new getID3;

        // Analyze file and store returned data in $ThisFileInfo
        $ThisFileInfo = $getID3->analyze($file);

        // Optional: copies data from all subarrays of [tags] into [comments] so
        // metadata is all available in one location for all tag formats
        // metainformation is always available under [tags] even if this is not called
        getid3_lib::CopyTagsToComments($ThisFileInfo);

        // Output desired information in whatever format you want
        // Note: all entries in [comments] or [tags] are arrays of strings
        // See structure.txt for information on what information is available where
        // or check out the output of /demos/demo.browse.php for a particular file
        // to see the full detail of what information is returned where in the array
        //echo @$ThisFileInfo['comments']['artist'][0]; // artist from any/all available tag formats

        $mim = @$ThisFileInfo['mime_type']; // artist from any/all available tag formats
        $dur = @$ThisFileInfo['playtime_string']; // play duration from any/all available tag formats

        switch (strrchr(strtolower($file), ".")) {
          case ".mp3";
            $tit = @$ThisFileInfo['id3v2']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['id3v2']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['id3v2']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['id3v2']['comments']['comment'][3]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['id3v2']['comments']['composer'][0]; // artist from any/all available tag formats
            $gen = @$ThisFileInfo['id3v2']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".m4a";
            $tit = @$ThisFileInfo['quicktime']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['quicktime']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['quicktime']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['quicktime']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['quicktime']['comments']['writer'][0]; // artist from any/all available tag formats
            // $gen = @$ThisFileInfo['quicktime']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".m4b";
            $tit = @$ThisFileInfo['quicktime']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['quicktime']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['quicktime']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['quicktime']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['quicktime']['comments']['writer'][0]; // artist from any/all available tag formats
            // $gen = @$ThisFileInfo['quicktime']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".mov";
            $tit = @$ThisFileInfo['quicktime']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['quicktime']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['quicktime']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['quicktime']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['quicktime']['comments']['director'][0]; // artist from any/all available tag formats
            // $gen = @$ThisFileInfo['quicktime']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".asf";
            $tit = @$ThisFileInfo['asf']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['asf']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['asf']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['asf']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['asf']['comments']['composer'][0]; // artist from any/all available tag formats
            $gen = @$ThisFileInfo['asf']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".wma";
            $tit = @$ThisFileInfo['asf']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['asf']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['asf']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['asf']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['asf']['comments']['composer'][0]; // artist from any/all available tag formats
            $gen = @$ThisFileInfo['asf']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          default;
            $tit = $file; // artist from any/all available tag formats
        }// end switch

        $this->title = stripJunk($tit);
        $this->composer = stripJunk($cmp);
        $this->album = stripJunk($alb);
        $this->comment = stripJunk($com);
        $this->copyright = stripJunk($cmp);
        $this->artist = stripJunk($art);
        $this->mime_type = stripJunk($mim);
        $this->duration = stripJunk($dur);
        return true;
      }else{
        return false; // file doesn't exist
      }// end if
    }//end funtion
  }// end class

  function getDir($mp3Dir, $supported_file_types) {
    // Returns directory as array[file]=date in newest to oldest order
    $dirArray = array();
    $diskdir = "./$mp3Dir/";
    if (is_dir($diskdir)) {
      $dh = opendir($diskdir);
      while (($file = readdir($dh)) != false ) {
        if (filetype($diskdir . $file) == "file" && $file[0]  != ".") {
          $fext = strrchr(strtolower($file), ".");
          if (strpos ($supported_file_types, $fext) > 0) {
            $ftime = filemtime($mp3Dir."/".$file);
            $dirArray[$file] = $ftime;
          }
        }
      }// end while
      closedir($dh);
    }
    asort($dirArray);
    $dirArray = array_reverse($dirArray);
    return $dirArray;
  }// end fuction

  /*
  Current iTunes category listings
  (Major Categories followed by Sub-Categories shown by asterisks below the Major Category)

  Arts
      * Design
      * Fashion & Beauty
      * Food
      * Literature
      * Performing Arts
      * Visual Arts

  Business
      * Business News
      * Careers
      * Investing
      * Management & Marketing
      * Shopping
  Comedy
  Education
      * Education Technology
      * Higher Education
      * K-12
      * Language Courses
      * Training
  Games & Hobbies
      * Automotive
      * Aviation
      * Hobbies
      * Other Games
      * Video Games
  Government & Organizations
      * Local
      * National
      * Non-Profit
      * Regional
  Health
      * Alternative Health
      * Fitness & Nutrition
      * Self-Help
      * Sexuality
  Kids & Family
  Music
  News & Politics
  Religion & Spirituality
      * Buddhism
      * Christianity
      * Hinduism
      * Islam
      * Judaism
      * Other
      * Spirituality
  Science & Medicine
      * Medicine
      * Natural Sciences
      * Social Sciences
  Society & Culture
      * History
      * Personal Journals
      * Philosophy
      * Places & Travel
  Sports & Recreation
      * Amateur
      * College & High School
      * Outdoor
      * Professional
  Technology
      * Gadgets
      * Tech News
      * Podcasting
      * Software How-To
  TV & Film
  */

?>
